// ActiveXTestCtrl.cpp : implmentation de la classe du contrle ActiveX CActiveXTestCtrl.

#include "stdafx.h"
#include "ActiveXTest.h"
#include "ActiveXTestCtrl.h"
#include "ActiveXTestPropPage.h"
#include "Util.h"
#include "Bloc.h"
#include "Plan.h"
#include "Pyramide.h"
#include "Maison.h"
#include "Village.h"
#include <algorithm>

#include "Util.h"
#include ".\activextestctrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


const DWORD IMAGESPARSECONDE = 20;
class Camera
{
   D3DXMATRIX m_MatriceVision;
   D3DXVECTOR3 m_Position,
               m_Direction,
               m_Haut;
public:
   void GlisserCameraDe (const D3DXVECTOR3 &Deplacement, IDirect3DDevice9 *pDevice)
   {
      m_Position += Deplacement;
      PositionnerCamera (pDevice);
   }
   void PositionnerCamera (IDirect3DDevice9 *pDevice)
   {
      // Dfinir la matrice de vision
      ::D3DXMatrixLookAtLH (&m_MatriceVision,
                            &m_Position,  // position
                            &m_Direction, // direction
                            &m_Haut);     // haut
      pDevice->SetTransform (D3DTS_VIEW, &m_MatriceVision);

      // Matrice de projection
      D3DXMATRIX MatriceProjection;

      const float CHAMP_VISION = D3DX_PI/4, // 45 degrs
                  RATIO_ASPECT = 1.0f,
                  PLAN_RAPPROCHE = 2.0f,
                  PLAN_ELOIGNE = 30.0f;
      ::D3DXMatrixPerspectiveFovLH (&MatriceProjection,
                                    CHAMP_VISION,
                                    RATIO_ASPECT,
                                    PLAN_RAPPROCHE,
                                    PLAN_ELOIGNE);
      pDevice->SetTransform (D3DTS_PROJECTION, &MatriceProjection);
   }
   Camera (IDirect3DDevice9 *pDevice)
      : m_Position  (0.0f, 7.5f, -10.0f),
        m_Direction (0.0f, 0.0f,   0.0f),
        m_Haut      (0.0f, 1.0f,   0.0f)
   {
      PositionnerCamera (pDevice);
   }
};

IMPLEMENT_DYNCREATE(CActiveXTestCtrl, COleControl)



// Table des messages

BEGIN_MESSAGE_MAP(CActiveXTestCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
   ON_WM_CREATE()
   ON_WM_DESTROY()
   ON_WM_KEYDOWN()
   ON_WM_LBUTTONDOWN()
   ON_WM_LBUTTONUP()
END_MESSAGE_MAP()



// Table de dispatch

BEGIN_DISPATCH_MAP(CActiveXTestCtrl, COleControl)
	DISP_FUNCTION_ID(CActiveXTestCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()



// Table d'vnement

BEGIN_EVENT_MAP(CActiveXTestCtrl, COleControl)
   EVENT_STOCK_CLICK()
END_EVENT_MAP()



// Pages de proprits

// TODO: ajoutez autant de pages de proprits que ncessaire. N'oubliez pas d'augmenter le compteur!
BEGIN_PROPPAGEIDS(CActiveXTestCtrl, 1)
	PROPPAGEID(CActiveXTestPropPage::guid)
END_PROPPAGEIDS(CActiveXTestCtrl)



// Initialisation de la fabrique de classe et du guid

IMPLEMENT_OLECREATE_EX(CActiveXTestCtrl, "ACTIVEXTEST.ActiveXTestCtrl.1",
	0x81459129, 0xd296, 0x414c, 0xb7, 0x53, 0xd7, 0xd9, 0x3b, 0x76, 0x93, 0xa0)



// ID et version de bibliothque de types

IMPLEMENT_OLETYPELIB(CActiveXTestCtrl, _tlid, _wVerMajor, _wVerMinor)



// ID d'interface

const IID BASED_CODE IID_DActiveXTest =
		{ 0x5BE5B464, 0xF474, 0x40F8, { 0x90, 0x76, 0xC3, 0xE2, 0x6C, 0x22, 0x24, 0xAA } };
const IID BASED_CODE IID_DActiveXTestEvents =
		{ 0x561A4C64, 0xD0F9, 0x48F6, { 0xA7, 0x93, 0x35, 0xC3, 0x42, 0x39, 0xBF, 0xF6 } };



// Informations de type du contrle

static const DWORD BASED_CODE _dwActiveXTestOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CActiveXTestCtrl, IDS_ACTIVEXTEST, _dwActiveXTestOleMisc)



// CActiveXTestCtrl::CActiveXTestCtrlFactory::UpdateRegistry -
// Ajoute ou supprime les entres de la base de registres pour CActiveXTestCtrl

BOOL CActiveXTestCtrl::CActiveXTestCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: vrifiez que votre contrle suit les rgles du modle de thread apartment.
	// Reportez-vous  MFC TechNote 64 pour plus d'informations.
	// Si votre contrle ne se conforme pas aux rgles du modle apartment, vous
	// devez modifier le code ci-dessous, en modifiant le 6 paramtre de
	// afxRegApartmentThreading en 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_ACTIVEXTEST,
			IDB_ACTIVEXTEST,
			afxRegApartmentThreading,
			_dwActiveXTestOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

namespace
{
   unsigned long __stdcall CompterTemps (void *p)
   {
      CActiveXTestCtrl *pCtrl = reinterpret_cast<CActiveXTestCtrl *> (p);
      while (!pCtrl->DoisMourir ())
      {
         if (!pCtrl->Animation ()) pCtrl->Meurs ();
         ::Sleep (0);
      }
      return 0L;
   }
}


// CActiveXTestCtrl::CActiveXTestCtrl - Constructeur

CActiveXTestCtrl::CActiveXTestCtrl()
   : m_TempsCourant (0L), m_TempsSuivant (0L), m_TempsVieux (0L),
     m_TempsEcart (0L), m_EchelleTemps (0.0), m_Rotation (0.0f),
     m_pD3D (0), m_pCamera (0), m_Meurs (false), m_RotationActive (true)
{
	InitializeIIDs(&IID_DActiveXTest, &IID_DActiveXTestEvents);
	// TODO: initialisez ici les donnes de l'instance de votre contrle.
}


// CActiveXTestCtrl::~CActiveXTestCtrl - Destructeur

CActiveXTestCtrl::~CActiveXTestCtrl()
{
}



// CActiveXTestCtrl::OnDraw - Fonction de dessin

//void CActiveXTestCtrl::OnDraw(
//			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
//{
//	if (!pdc)
//		return;
//
//	// TODO: remplacez le code suivant par votre code dessin.
//	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
//	pdc->Ellipse(rcBounds);
//}



// CActiveXTestCtrl::DoPropExchange - Prise en charge de la persistance

void CActiveXTestCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: appelez les fonctions PX_ pour chaque proprit personnalise persistante.
}



// CActiveXTestCtrl::OnResetState - Rinitialise le contrle  son tat par dfaut

void CActiveXTestCtrl::OnResetState()
{
	COleControl::OnResetState();  // Rinitialise les valeurs par dfaut trouves dans DoPropExchange

	// TODO: rinitialisez ici les autres valeurs d'tat du contrle.
}



// CActiveXTestCtrl::AboutBox - Affiche une bote de dialogue " propos de"  l'utilisateur

void CActiveXTestCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_ACTIVEXTEST);
	dlgAbout.DoModal();
}



// Gestionnaires de messages CActiveXTestCtrl

int CActiveXTestCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   if (COleControl::OnCreate(lpCreateStruct) == -1)
      return -1;

   //
   // Rendre la fentre carre (minimum des dimensions par dfaut)
   //
/*
   RECT r = { 0 };
   GetWindowRect (&r);
   const long LARGEUR = r.right- r.left;
   const long HAUTEUR = r.bottom - r.top;
   const long TAILLE = (LARGEUR < HAUTEUR? LARGEUR : HAUTEUR);
   r.right = TAILLE + r.left;
   r.bottom = TAILLE + r.top;
   MoveWindow (&r, TRUE);
*/

   // Initialisation des lments de DX
   try
   {
      // Cration de l'Environnement DX
      InitDirect3D();

      // Cration et initialsiation de la scne
      if (!InitScene ()) return -1;

      // Initialisation de l'animation et prparation de la 1ire image
      if (!InitAnimation ()) return -1;

      //
      // Lancement du thread qui va nosu informer du passage du temps...
      //
      DWORD Id;
      hTh = ::CreateThread (0, 0, ::CompterTemps, this, 0, &Id);
   }
   catch (HRESULT hr)
   {
      CString Msg;
      if (!hr)
         Msg = "chec de l'opration";
      else
         Msg.Format ("chec de l'opration, code %d", hr);
      MessageBox (Msg, "Erreur");
      return -1;
   }

   return 0;
}

//
// Initialiser les paramtres de l'animation et prparer la 1ire image
//
bool CActiveXTestCtrl::InitAnimation()
{
   // ::timeGetTime(): winmm.lib, nb ms depuis dmarrage de Windows,
   // prcis  5ms prs
   m_TempsSuivant = ::timeGetTime ();
   m_EchelleTemps = 0.001;
   m_TempsEcart = 1000/IMAGESPARSECONDE;
   m_TempsVieux = m_TempsSuivant;

   // Prparer la 1ire image
   RendreScene();
   return true;
}

//
// Prparer une image dans le backbuffer. En version optimise, cette
// mthode ne fait pas d'affichage
//

namespace
{
   class Afficher
   {
      IDirect3DDevice9 *m_pD3DDevice;
   public:
      Afficher(IDirect3DDevice9 *pDevice) : m_pD3DDevice(pDevice) {}
      ~Afficher () {}
      void operator () (IDessinable *p) { if (p) p->Draw (m_pD3DDevice); }
   };
}

bool CActiveXTestCtrl::RendreScene()
{
   const D3DCOLOR COULEUR_FOND = D3DCOLOR_XRGB (0, 0, 255);

   // Effacer le viewport en bleu
   m_pD3DDevice->Clear (0, 0, // lis aux rectangles  effacer (ici, on efface tout)
                        D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, // quoi effacer. Ici, surface de destination et Z-Buffer
                        COULEUR_FOND, // couleur  appliquer
                        1.0f, 0L); // effets

   // Le rendu  proprement dit
   m_pD3DDevice->BeginScene ();
   std::for_each (m_ObjetsDessinables.begin(), m_ObjetsDessinables.end(), Afficher (m_pD3DDevice));
   m_pD3DDevice->EndScene ();
   return true;
}

//
// Mthode d'animation. Optimise pour les systmes les moins rapides
// (effectue le flip au dbut du signal, puis construit la prochaine
// image).
bool CActiveXTestCtrl::Animation ()
{
   float TempsEcoule (0.0f);

   m_TempsCourant = ::timeGetTime ();

   // Temps pour une nouvelle image?
   if (m_TempsCourant > m_TempsSuivant)
   {
      // Affichage optimis
      m_pD3DDevice->Present (0, 0, 0, 0);

      TempsEcoule = 
         static_cast<float>((m_TempsCourant - m_TempsVieux) * m_EchelleTemps);

      // Prparer la prochaine image
      AnimeScene (TempsEcoule);

      // Rendre l'image sur la surface de travail
      RendreScene ();

      // Calcul du temps du prochai naffichage
      m_TempsVieux = m_TempsCourant;
      m_TempsSuivant = m_TempsCourant + m_TempsEcart;
   }
   return true;
}

//
// Initialisation de D3D
//
void CActiveXTestCtrl::InitDirect3D()
{
   // 1. Cration de l'objet D3D
   Valider (m_pD3D = Direct3DCreate9 (D3D_SDK_VERSION));

   // 2. Obtenir le mode d'affichage courant
   D3DDISPLAYMODE d3ddm;
   Essayer (m_pD3D->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm));

   // 3. Initialiser l'enregistrement utilis pour crer le dispositif D3DDevice
   // - la plupart des paramtres sont mis  zro
   // - le champ windowed est TRUE: nous voulons du 3D dans une fentre
   // - le champ SwapEffect est discard, ce uqi est le moyen le plus rapide
   //   d'changer le backbuffer avec l'cran
   // - le backbuffer demand rencontrera les caractristiques du mode d'affichage
   //   courant.
   D3DPRESENT_PARAMETERS d3dpp = { 0 }; 
   d3dpp.Windowed = TRUE;
   d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
   d3dpp.BackBufferFormat = d3ddm.Format;

   // Implantation d'un tampon de profondeur
   d3dpp.EnableAutoDepthStencil = TRUE;
   d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

   // 4. Cration du dispositif D3ddevice
   // - nous utilisons la carte vido par dfaut, puisuqe la plupart des systmes
   //   n'en ont qu'une seule
   // - software vertex processing est utilis parce qu'il fonctionnera sur
   //   toutes les cartes. On obtient une meilleure performance avec hardware
   //   vertex processing sur les cartes qui le supportent.
   Essayer ( m_pD3D->CreateDevice ( D3DADAPTER_DEFAULT,
                                    D3DDEVTYPE_HAL,
                                    m_hWnd,
                                    D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                    &d3dpp,
                                    &m_pD3DDevice) );

   // Activation du traitement des surfaces caches
   m_pD3DDevice->SetRenderState (D3DRS_ZENABLE, TRUE);

}

bool CActiveXTestCtrl::InitScene ()
{
   // Initialisation des objets 3D (cration / chargement)
   if (!InitObjets ()) return false;
   // Initialisation des clairages
   if (!InitEclairage ()) return false;
   // Initialisation des transformations
   if (!InitTransformations()) return false;

   return true;
}

bool CActiveXTestCtrl::InitObjets ()
{
   m_ObjetsDessinables.push_back (new Village (m_pD3DDevice));
   return true;
}

bool CActiveXTestCtrl::InitEclairage ()
{
   // Choix: lumire blanche pure
   m_pD3DDevice->SetRenderState (D3DRS_AMBIENT, 0xffffffff); // ou ~0
   return true;
}

bool CActiveXTestCtrl::InitTransformations ()
{
   m_pCamera = new Camera (m_pD3DDevice);
   return true;
}

//
// Animer la scne
//

namespace // dclarations locales
{
   class Tourner
   {
      const float m_Rotation;
      int m_CptObjets;
   public:
      Tourner (const float Rotation)
         : m_Rotation (Rotation), m_CptObjets (0)
      {
      }
      ~Tourner () {}
      void operator() (IDessinable *p)
      {
         const D3DXVECTOR3 Position = p->GetPosition ();
         const int NB_AXES = 3;
         D3DXMATRIX Monde = p->GetMatriceMonde (),
                     TranslationVersOrigine,
                     Rotation,
                     TranslationVersPosition;
         ::D3DXMatrixTranslation (&TranslationVersOrigine,  -Position.x, -Position.y, -Position.z);
         ::D3DXMatrixTranslation (&TranslationVersPosition,  Position.x,  Position.y,  Position.z);
         switch (m_CptObjets++)
         {
         case 0:
            // Modifier la matrice de l'objet
            ::D3DXMatrixRotationX (&Rotation, m_Rotation);
            break;
         case 1:
            // Modifier la matrice de l'objet
            ::D3DXMatrixRotationY (&Rotation, m_Rotation);
            break;
         case 2:
            // Modifier la matrice de l'objet
            ::D3DXMatrixRotationZ (&Rotation, m_Rotation);
            break;
         default:;
         }
         p->GetMatriceMonde () = TranslationVersOrigine * Rotation * TranslationVersPosition;
      }
   };
}

bool CActiveXTestCtrl::AnimeScene (float TempsEcoule)
{
   m_Rotation += ( D3DX_PI * 2.0f / 3.0f * TempsEcoule );
   // On tourne les maisons
   if (m_RotationActive)
      std::for_each (m_ObjetsDessinables.begin (), m_ObjetsDessinables.end (),
                     Tourner (m_Rotation));
   return true;
}

//
// Nettoyage...
//

namespace // dclarations locales
{
   template <class T>
   void Detruire (T *p) { delete p; }
}

void CActiveXTestCtrl::Nettoyer ()
{
   Meurs ();
   ::WaitForSingleObject (hTh, INFINITE);
   ::CloseHandle (hTh);
   std::for_each (m_ObjetsDessinables.begin (), m_ObjetsDessinables.end (),::Detruire<IDessinable>);
   m_ObjetsDessinables.clear ();
   delete m_pCamera;
   // Relcher les interfaces graphiques
   Relacher (m_pD3DDevice);
   Relacher (m_pD3D);
}


void CActiveXTestCtrl::OnDestroy()
{
   COleControl::OnDestroy();
   Nettoyer ();
}

void CActiveXTestCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
   switch (nChar)
   {
   case VK_UP:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 ( 1.0f, 0.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_DOWN:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (-1.0f, 0.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_RIGHT:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f, -1.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_LEFT:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f,  1.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_HOME:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f, 0.0f, -1.0f), m_pD3DDevice);
      break;
   case VK_END:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f, 0.0f,  1.0f), m_pD3DDevice);
      break;
   }
   COleControl::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CActiveXTestCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
   ToggleRotation ();
   COleControl::OnLButtonUp(nFlags, point);
}
