#include "Maison.h"
#include "Bloc.h"
#include "Pyramide.h"
#include <algorithm>

namespace
{
   template<class T> void Detruire (T *p)
   {
      delete p;
   }
   class Dessiner
   {
      IDirect3DDevice9 *m_pDevice;
   public:
      Dessiner (IDirect3DDevice9 *pDevice) : m_pDevice (pDevice) { }
      virtual ~Dessiner () { }
      void operator () (IDessinable *p) { p->DrawNoTransform (m_pDevice); }
   };
}


Maison::Maison (const D3DXVECTOR3 &Position, IDirect3DDevice9 *pDevice)
   : IDessinable (Position)
{
   m_Parties.push_back (new Bloc (Position, // D3DXVECTOR3 (-1.0f, -1.0f, -2.0f),
                        D3DXVECTOR3 ( 2.0f,  2.0f,  2.0f), pDevice));
   m_Parties.push_back (new Pyramide (Position + D3DXVECTOR3 (1.0f,  1.0f,  2.0f), 2.0f, pDevice));
}

Maison::~Maison ()
{
   std::for_each (m_Parties.begin(), m_Parties.end (), ::Detruire<IDessinable>);
}

void Maison::Draw(IDirect3DDevice9 *pDevice)
{
   // Matrice de transformation dans le monde
   pDevice->SetTransform (D3DTS_WORLD, &m_MatriceMonde);
   DrawNoTransform (pDevice);
}

void Maison::DrawNoTransform(IDirect3DDevice9 *pDevice)
{
   std::for_each (m_Parties.begin(), m_Parties.end (), ::Dessiner (pDevice));
}
