#ifndef PYRAMIDE_H
#define PYRAMIDE_H

#include "stdafx.h"
#include "IDessinable.h"

class Pyramide : public IDessinable
{
   IDirect3DVertexBuffer9 *m_pVB;
   IDirect3DIndexBuffer9 *m_pIB;
   D3DMATERIAL9 m_Materiau;
   enum
   {
      // Base
      NB_FACES_BASE = 1,
      NB_SOMMETS_FACE_BASE = 4,
      // Haut
      NB_FACES_HAUT = 4,
      NB_SOMMETS_FACE_HAUT = 3,
      // Commun base/ haut
      NB_SOMMETS_DISTINCTS = 5,
      NB_FACES = NB_FACES_BASE + NB_FACES_HAUT,
      NB_SOMMETS = NB_FACES_BASE * NB_SOMMETS_FACE_BASE +
                   NB_FACES_HAUT * NB_SOMMETS_FACE_HAUT,
      NB_SOMMETS_PRIMITIVE = 3, // des triangles
      NB_PRIMITIVES = 2 * NB_FACES_BASE + 1 * NB_FACES_HAUT,
      NB_SOMMETS_PRIMITIVES = NB_PRIMITIVES * NB_SOMMETS_PRIMITIVE
   };
   static const WORD Index[NB_SOMMETS_PRIMITIVES];
   void InitIndexBuffer (IDirect3DDevice9 *pDevice);
public:
   Pyramide  (const D3DXVECTOR3 &Position,
              const float LgCote,
              IDirect3DDevice9 *pDevice);
   virtual ~Pyramide ();
   void SetMateriaux (const D3DMATERIAL9 &Materiau);
   void InitMateriaux ();
   virtual void Draw(IDirect3DDevice9 *pDevice);
   virtual void DrawNoTransform(IDirect3DDevice9 *pDevice);
};

#endif // !defined PYRAMIDE_H
